# coding: utf-8

from __future__ import unicode_literals

import logging
from urllib2 import urlopen, HTTPError, URLError

from tionix_autosetup.executors.base import (
    BaseConnectionCheckExecutor, ConnectionCheckException)

logger = logging.getLogger(__name__)


class KeystoneConnectionCheck(BaseConnectionCheckExecutor):
    name = 'Keystone'

    def check_connection(self, var_dict):
        keystone_msg = 'Keystone is not available.'
        valid_codes = [300, 200]
        keystone_url = var_dict.get('AUTH_URL')
        opened = None
        try:
            opened = urlopen(keystone_url)
        except HTTPError as err:
            if err.code not in valid_codes:
                raise ConnectionCheckException(keystone_msg)
        except URLError:
            raise ConnectionCheckException(keystone_msg)
        finally:
            if opened:
                opened.close()
