# coding: utf-8

from __future__ import unicode_literals

from tionix_autosetup import tionix
from tionix_autosetup import tionix_cloud_control
from tionix_autosetup import tionix_dashboard
from tionix_autosetup import tionix_monitor
from tionix_autosetup import tionix_node_control
from tionix_autosetup import tionix_scheduler
from tionix_autosetup import tionix_vdi_server
from tionix_autosetup.tionix.configure import BaseConfig
from tionix_autosetup.helpers import PackageTypesEnum


PIP = PackageTypesEnum.PIP


class PACKAGES(object):

    TIONIX = 'TIONIX'
    TIONIX_CC = 'TIONIX.CloudControl'
    TIONIX_Dashboard = 'TIONIX.Dashboard'
    TIONIX_Monitor = 'TIONIX.Monitor'
    TIONIX_NC = 'TIONIX.NodeControl'
    TIONIX_Scheduler = 'TIONIX.Scheduler'
    TIONIX_VDIServer = 'TIONIX.VDIServer'

    active = [
        TIONIX,
        TIONIX_CC,
        TIONIX_Dashboard,
        TIONIX_Monitor,
        TIONIX_NC,
        TIONIX_Scheduler,
        TIONIX_VDIServer,
    ]

    variable_box_fabric = {
        TIONIX: tionix.default_fabric,
        TIONIX_CC: tionix_cloud_control.variable_box_fabric,
        TIONIX_Dashboard: tionix_dashboard.variable_box_fabric,
        TIONIX_Monitor: tionix_monitor.variable_box_fabric,
        TIONIX_NC: tionix_node_control.variable_box_fabric,
        TIONIX_Scheduler: tionix_scheduler.variable_box_fabric,
        TIONIX_VDIServer: tionix_vdi_server.variable_box_fabric,
    }

    custom_variables = {
        TIONIX_CC: tionix_cloud_control.custom_variables,
        TIONIX_Dashboard: tionix_dashboard.custom_variables,
        TIONIX_Monitor: tionix_monitor.custom_variables,
        TIONIX_NC: tionix_node_control.custom_variables,
        TIONIX_Scheduler: tionix_scheduler.custom_variables,
        TIONIX_VDIServer: tionix_vdi_server.custom_variables,
    }

    pip_names = {
        TIONIX_CC: tionix_cloud_control.package_names[PIP],
        TIONIX_Dashboard: tionix_dashboard.package_names[PIP],
        TIONIX_Monitor: tionix_monitor.package_names[PIP],
        TIONIX_NC: tionix_node_control.package_names[PIP],
        TIONIX_Scheduler: tionix_scheduler.package_names[PIP],
        TIONIX_VDIServer: tionix_vdi_server.package_names[PIP],
    }

    config_path = {
        TIONIX: BaseConfig.config_path,
        TIONIX_CC: tionix_cloud_control.CloudControlConfig.config_path,
        TIONIX_Dashboard: tionix_dashboard.DashboardConfig.config_path,
        TIONIX_Monitor: tionix_monitor.MonitorConfig.config_path,
        TIONIX_NC: tionix_node_control.NodeControlConfig.config_path,
        TIONIX_Scheduler: tionix_scheduler.SchedulerConfig.config_path,
        TIONIX_VDIServer: tionix_vdi_server.VDIServerConfig.config_path,
    }

    pipelines = {
        TIONIX: tionix.pipeline,
        TIONIX_CC: tionix_cloud_control.pipeline,
        TIONIX_Dashboard: tionix_dashboard.pipeline,
        TIONIX_Monitor: tionix_monitor.pipeline,
        TIONIX_NC: tionix_node_control.pipeline,
        TIONIX_Scheduler: tionix_scheduler.pipeline,
        TIONIX_VDIServer: tionix_vdi_server.pipeline,
    }

    update_pipelines = {
        TIONIX: tionix.update_pipeline,
        TIONIX_CC: tionix_cloud_control.update_pipeline,
        TIONIX_Dashboard: tionix_dashboard.update_pipeline,
        TIONIX_Monitor: tionix_monitor.update_pipeline,
        TIONIX_NC: tionix_node_control.update_pipeline,
        TIONIX_Scheduler: tionix_scheduler.update_pipeline,
        TIONIX_VDIServer: tionix_vdi_server.update_pipeline,
    }

    uninstall_pipelines = {
        TIONIX: tionix.uninstall_pipeline,
        TIONIX_CC: tionix_cloud_control.uninstall_pipeline,
        TIONIX_Dashboard: tionix_dashboard.uninstall_pipeline,
        TIONIX_Monitor: tionix_monitor.uninstall_pipeline,
        TIONIX_NC: tionix_node_control.uninstall_pipeline,
        TIONIX_Scheduler: tionix_scheduler.uninstall_pipeline,
        TIONIX_VDIServer: tionix_vdi_server.uninstall_pipeline,
    }

    connections_check_pipelines = {
        TIONIX: tionix.connections_check_pipeline,
        TIONIX_CC: tionix_cloud_control.connections_check_pipeline,
        TIONIX_Dashboard: tionix_dashboard.connections_check_pipeline,
        TIONIX_Monitor: tionix_monitor.connections_check_pipeline,
        TIONIX_NC: tionix_node_control.connections_check_pipeline,
        TIONIX_Scheduler: tionix_scheduler.connections_check_pipeline,
        TIONIX_VDIServer: tionix_vdi_server.connections_check_pipeline,
    }

    post_check_pipelines = {
        TIONIX: tionix.post_check_pipeline,
        TIONIX_CC: tionix_cloud_control.post_check_pipeline,
        TIONIX_Dashboard: tionix_dashboard.post_check_pipeline,
        TIONIX_Monitor: tionix_monitor.post_check_pipeline,
        TIONIX_NC: tionix_node_control.post_check_pipeline,
        TIONIX_Scheduler: tionix_scheduler.post_check_pipeline,
        TIONIX_VDIServer: tionix_vdi_server.post_check_pipeline,
    }

    prefixes = {
        TIONIX_CC: tionix_cloud_control.variables_prefix,
        TIONIX_Dashboard: tionix_dashboard.variables_prefix,
        TIONIX_Monitor: tionix_monitor.variables_prefix,
        TIONIX_NC: tionix_node_control.variables_prefix,
        TIONIX_Scheduler: tionix_scheduler.variables_prefix,
        TIONIX_VDIServer: tionix_vdi_server.variables_prefix,
    }

    rollback_pipelines = {
        TIONIX: tionix.rollback_pipeline,
    }
