# coding: utf-8

from __future__ import unicode_literals

from tionix_autosetup.executors.base import fabric
from tionix_autosetup.variables import DBNameVar, RabbitVirtHostVar


variables_prefix = 'TNX_CC'


class CCDBNameVar(DBNameVar):
    default = 'tionix_cloud_control'


class CCRabbitVirtHostVar(RabbitVirtHostVar):
    default = 'tionix_cc_vhost'


custom_variables = {
    CCDBNameVar.name: CCDBNameVar,
    CCRabbitVirtHostVar.name: CCRabbitVirtHostVar,
}


@fabric
def variable_box_fabric(box_cls, **kwarg):
    instance = box_cls(
        variables_prefix=variables_prefix,
        custom_variables=custom_variables,
        **kwarg)
    return instance
