# coding: utf-8

from __future__ import unicode_literals

from tionix_autosetup.executors.base import fabric
from tionix_autosetup.variables import DBNameVar, ModuleBaseVar


variables_prefix = 'TNX_SCH'


class SchedulerDBNameVar(DBNameVar):
    default = 'tionix_scheduler'


class SchedulerHostVar(ModuleBaseVar):
    """TIONIX.Scheduler host"""
    name = 'SCHEDULER_HOST'
    default = 'localhost'


custom_variables = {
    SchedulerDBNameVar.name: SchedulerDBNameVar,
    SchedulerHostVar.name: SchedulerHostVar,
}


@fabric
def variable_box_fabric(box_cls, **kwarg):
    instance = box_cls(
        variables_prefix=variables_prefix,
        custom_variables=custom_variables,
        **kwarg)
    return instance
