# coding: utf-8

from __future__ import unicode_literals

from tionix_autosetup.executors.base import fabric
from tionix_autosetup.variables import DBNameVar, RabbitVirtHostVar


variables_prefix = 'TNX_VDI'


class VDIServerRabbitVirtHostVar(RabbitVirtHostVar):
    default = 'tionix_vdi_server_vhost'


class VDIServerDBNameVar(DBNameVar):
    default = 'tionix_vdi_server'


custom_variables = {
    VDIServerDBNameVar.name: VDIServerDBNameVar,
    VDIServerRabbitVirtHostVar.name: VDIServerRabbitVirtHostVar,
}


@fabric
def variable_box_fabric(box_cls, **kwarg):
    instance = box_cls(
        variables_prefix=variables_prefix,
        custom_variables=custom_variables,
        **kwarg)
    return instance
