# coding: utf-8

import sys


class BaseWriter(object):
    """Writer interface"""
    def init_writer(self):
        raise NotImplementedError

    def write(self, message):
        raise NotImplementedError

    def close_writer(self):
        raise NotImplementedError


class StdOutWriter(object):
    """Writer for stdout"""
    def __init__(self, stdout=sys.stdout):
        self.stdout = stdout

    def __repr__(self):
        return u"StdOutWriter(stdout='{0}')".format(self.stdout)

    def init_writer(self):
        pass

    def write(self, message):
        self.stdout.write(message)

    def close_writer(self):
        pass
